ADN Open CIS
Сообщество программистов Autodesk в СНГ

21/02/2014

Загружаем тип линии в неактивный документ

Следующий код загружает типы линий, начинающиеся на литеру 'H' из файла acad.lin во все открытые документы. Заметим что команда должна быть зарегистрирована для контекста приложения (т.е. с флагом ACRX_CMD_SESSION).

Опубликовано 21.02.2014     Читать далее >>>
19/02/2014

Создаем копию текущего документа в новом документе.

Вопрос:
Как можно создать точную копию текущего документа в новом документе?

Решение:
Одно из решений – сначала создание временного файла-шаблона из текущего файла, а затем создание нового чертежа из этого шаблона. Затем шаблон можно удалить. Вот шаги, которые последовательно нужно проделать:

Опубликовано 19.02.2014     Читать далее >>>
15/02/2014

Подавление команд AutoCAD

Метод acedRegCmds->removeCmd(), работает только с командами, зарегистрированными из ARX приложения. Этим способом нельзя отменить встроенные команды AutoCAD. Команда AutoCAD _UNDEFINE предназначена именно для подавления встроенных команд. Так как после команд _OPEN и/или _NEW команды переопределяются AutoCAD’ом, необходимо вызывать команду _UNDEFINE каждый раз, когда AutoCAD посылает уведомление kLoadDwgMsgвашей программе.
Опубликовано 15.02.2014     Читать далее >>>
04/02/2014

Сохранение собственных значений на уровне dwg-файлаАвтор: Александр Ривилис

Вопрос:
Есть необходимость хранить в чертеже (dwg-файле) информацию, относящуюся ко всему чертежу. Формат информации – целые или вещественные числа, строки и координаты точек. Необходимо обеспечить соответствие имени переменной (например, Scale) и его значению (например, 1.0). Как это проще и удобнее всего сделать.

Ответ:
Для таких целей удобнее всего использовать Named Object Dictionary (NOD):

Для этой цели в корневом словаре мы создаем дочерний словарь с именем заданным переменной appName и внутри него для каждой из созданных переменных с именем varName будем хранить их значения varValue в примитиве XRecord.

Опубликовано 04.02.2014     Читать далее >>>
22/01/2014

Вставка растрового изображения с использованием буфера изображения

Можно использовать метод AcDbRasterImageDef::setImage в случае если вы не хотите указывать путь к файлу растрового изображения при вставке изображения. Это можно считать еще одним подходм для выполнения того, что объясняется в этой статье.
Опубликовано 22.01.2014     Читать далее >>>
20/01/2014

Встраивание изображения в чертеж

Вопрос:

Как можно встроить изображение в чертеж так, чтобы не было необходимости передавать отдельный от чертежа растровый файл?

Ответ:

Это можно сделать двумя способами. Метод зависит от ваших требований.

Опубликовано 20.01.2014     Читать далее >>>
13/01/2014

Контекстное меню ручек с использованием AcDbMultiModesGripPE

Это пример проекта, который реализует контекстное меню ручек для собственного примитива с использованием класса AcDbMultiModesGripPE. Он демонстрирует использование мультирежимных ручек, которые выполняют ввод в зависимости от собственного примитива.

Чтобы было веселее, я создал собственный примитив, который напоминает дерево. Контекстное меню его ручек показывает два режима: "Spring" (весна) and "Winter" (зима). После того как собственный примитив дерева создан, контекстное меню появляется, когда курсор оказывается возле ручки (ручка становится «теплой»). Выбор "Spring" (весна) приводит к тому, что у дерева появляются листья, а при выборе "Winter" (зима) дерево сбрасывает листья.

Опубликовано 13.01.2014     Читать далее >>>
06/01/2014

Запуск инструмента из инструментальной палитры

Это пример кода, который запускает инструмент "Шестигранная гайка - метрические" доступный в инструментальной палитре "Оборудование" в AutoCAD. Он проходит по каталогу инструментов, находит соответствующий и запускает инструмент. Это подобно нажатию левой кнопки мыши на инструменте в пользовательском интерфейсе AutoCAD.

Опубликовано 06.01.2014     Читать далее >>>
23/12/2013

Добавление и удаление примитивов из набора предварительного выбора в ObjectARX

Вы можете воспользоваться функцией “acedSSSetFirst” для создания набора (с «ручками») предварительного выбора. Ниже пример команды, которая запрашивает выбор примитивов и помещает их в набор предварительного выбора. Код также показывает окно сообщений, и как только нажимаете «Да», набор удаляется из набора предварительного выбора. Заметим, что команда позволяющая выбирать и устанавливать набор предварительного выбора должна иметь флаги ACRX_CMD_USEPICKSET и ACRX_CMD_REDRAW

Опубликовано 23.12.2013     Читать далее >>>
20/12/2013

Получение информации из прокси-примитивов

Вы можете воспользоваться классом “AcDbProxyEntity” для получения оригинального имени класса, оригинального dxf-имени и числа ссылок на этот примитив в файле чертежа.

Ниже код, который получает “originalClassName” и “originalDxfName” прокси-примитива.

Опубликовано 20.12.2013     Читать далее >>>
18/12/2013

Удаление всех прокси-примитивов из чертежа средствами ObjectARX

Вопрос:

Я хочу работать с чертежом, содержащем пользовательские объекты, для которых у меня нет соответствующего приложения. Я бы хотел использовать данные из чертежа для построения новой «геометрии». Какие-то примитивы можно расчленить, а какие-то нет. И они отмечены как неудаляемые. Я создаю эквивалент для этих примитивов, а вот удалить их не могу. Возможно ли их удалить?

Ответ
Средствами ObjectARX можно заменить прокси-примитивы на какие-то другие. Следующий код делает именно это: проходит по всем примитивам чертежа, переключая все прокси-примитивы на анонимные блоки. Блоки содержат эквивалентную геометрию прокси-примитивов. Заметим, что нельзя создать примитив содержащий ту же информацию, что и исходный примитив.

Опубликовано 18.12.2013     Читать далее >>>
16/12/2013

Расчленение всех примитивов из набора

Ниже код для расчленения всех примитивов из набора. Мы используем метод explode() класса AcDbEntity class и результат расчленения сохраняется в массиве AcDbVoidPtrArray. Все примитивы из AcDbVo

Опубликовано 16.12.2013     Читать далее >>>
13/12/2013

Использование набора предварительного выбора в команде копирования

Вопрос :

У меня есть набор предварительного выбора и я хотел бы получить его копию сразу и целиком, а не копировать последовательно каждый примитив из набора при помощи вызова функции acedCommand (RTSTR, "_copy",..). Есть ли возможность вызвать однократно acedCommand (RTSTR, "_copy",..) для всего набора, как это делает AutoCAD?

Ответ :
Вы можете использовать набор, передав RTPICKS и набор в функцию acedCommand:

Опубликовано 13.12.2013     Читать далее >>>
11/12/2013

Выбор определенных примитивов из набора предварительного выбора

Системная переменная 'PICKFIRST' будучи установленной в '1' позволяет пользователю выбрать примитивы до запуска команды AutoCAD. Это применимо и к командам, созданным при помощи ObjectARX.

Есть две ARX-функции, которые позволяют получить набор предварительного выбора. Это функция acedSSGet() с опцией "_I", и чаще используемая функция acedSSGetFirst(). Это демонстрирует следующий код. Имя команды 'pfss'.

Если пользователь предварительно выберет примитивы и запустит команду 'pfss', эти примитивы попадут в набор 'pfSet'. Проверим , что число элементов в наборе больше нуля и если это так, то выполним цикл 'for'. В цикле 'for' получаем ObjectId каждого примитива и открываем примитив «для чтения». Проверяем примитив при помощи функции 'isA()'. Вы можете аналогично проверить и пользовательские примитивы если замените имя на имя пользовательского класса.

Опубликовано 11.12.2013     Читать далее >>>
09/12/2013

Как определить направление вращения замкнутой полилинии?

Чтобы определить направление вращения полилинии по часовой или против часовой стрелки можно пройтись по всем сегментам полилинии и проверить лежит ли он справа или слева. Следующий код делает именно это. Он подсчитывает сумму числа поворотов для всех сегментов. Повороты возможны внутри сегментов (если они дуговые) или между последовательными сегментами. Результат работы функции – число поворотов. Если поворот налево – число положительное, если поворот направо – отрицательное. Заметим, что алгоритм не определяет, является ли полилиния самопересекающейся и может даже давать ошибочные результаты если полилиния действительно самопересекающаяся.

Опубликовано 09.12.2013     Читать далее >>>
04/12/2013

Передача списка значений в ObjectARX из Lisp приводит к ошибке

Вопрос:

Передача списка значений в ObjectARX-функцию из Lisp приводит к ошибкам в том случае, когда некоторые значения чисел (Пример: 5011, 25111) являются частью списка. Как этого избежать?

Ответ:

Некоторые числовые значения интерпретируются как DXF-коды, что и приводит к исключениям.

Опубликовано 04.12.2013     Читать далее >>>
02/12/2013

Получение копий сложных объектов без помещения их в базу

Используя ObjectARX вы можете создать копию одиночного простого объекта без помещения в базу при помощи методов clone() или copyFrom(). Но эти два метода не работают со сложными объектами, такими как AcDbBlockReference (вставка блока) с AcDbAttribute (атрибут). Как описано в документации, метод clone() вызывает метод copyFrom(), который делает поверхностную копию объекта. Другими словами, эти методы не копируют объекты атрибутов (AcDbAttribute). И не существует прямого метода в ObjectARX чтобы получить полную копию сложного объекта.

Опубликовано 02.12.2013     Читать далее >>>
22/10/2013

Как показать диалоговое окно редактирования поля (Field) средствами ObjectARX

Вы можете показать диалоговое окно AutoCAD редактирования поля, используя функцию “AcFdUiInvokeFieldDialog”. При помощи этой функции можно показать диалог и вернуть объект поля, выбранный пользователем, переданный как первый параметр. Код ниже показывает как это сделать:

Опубликовано 22.10.2013     Читать далее >>>
19/10/2013

Изменение цвета вершины у сети (SubDMesh)

Чтобы назначить цвета вершинам сети (SubDMesh), примитив сети (SubDMesh) должен быть предварительно добавлен в базу данных чертежа, прежде чем вызвать метод "AcDbSubDMesh::setVertexColorArray". Вот пример:

Опубликовано 19.10.2013     Читать далее >>>